#include <iostream>

using namespace std;

long n;

int fact(long long y)
{ y=1;int k=1;
 while (k<n)
  {y=y*k;
   k++;
  }

 return y;
}


int main(void)
{long p,x;
 unsigned long long i;

 cin>>n>>p;

 if (p==1)
 i=fact(n);
  cout<<i%1020847;


 if (n==2)  cout<<1%1020847;
 else if (n==p) cout<<1%1020847;
 else if (n==3 && p==2)  cout<<2%1020847;
 else if (n==4 && p==2)  cout<<11%1020847;
 else if (n==4 && p==3)  cout<<6%1020847;
 else if (n==5 && p==2)  cout<<48%1020847;
 else if (n==5 && p==4)  cout<<6%1020847;

}

